import os, string, time
import OFS, Globals
from ZODB.DB import DB
import ZODB.ZApplication
import OFS.Application
import SubApplication
import AccessControl.User, AccessControl.SecurityManagement
from App.ApplicationManager import ApplicationManager

class SubApplication(OFS.Application.Application):
    """ An Application suitable for inserting into non-main ZODBs """

    _reserved_names=('Control_Panel',)
    isPrincipiaFolderish=1
    isTopLevelPrincipiaApplicationObject=0

    def id(self):
	return self.title

def createNewApplication(db, id):
    """ create the bits needed in a new ZODB. This code copied
	pretty much intact from Zope/__init__.py
    """
    # "Log on" as system user
    AccessControl.SecurityManagement.newSecurityManager(
	None, AccessControl.User.system)
    # Set up the "application" object that automagically opens
    # connections
    app=bobo_application=ZODB.ZApplication.ZApplicationWrapper(
	db, 'Application', SubApplication, (),
	Globals.VersionNameName)
    print "app created"
    # Initialize products:
    c=app()
    try:
	c.title = id
    except:
	pass
    OFS.Application.initialize(c)
    c._p_jar.close()
    del c
    # "Log off" as system user
    AccessControl.SecurityManagement.noSecurityManager()

